Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/builder.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -1779,35 +1937,35 @@
 int main(int argc, char **argv)
 {
-	periodentafel *periode = new periodentafel; // and a period table of all elements
-	MoleculeListClass *molecules = new MoleculeListClass;  // list of all molecules
-	molecule *mol = NULL;
-	config configuration;
-	char choice;	// menu choice char
-	Vector x,y,z,n;	// coordinates for absolute point in cell volume
-	ifstream test;
-	ofstream output;
-	string line;
-	char *ConfigFileName = NULL;
-	int j, count;
-
-	// =========================== PARSE COMMAND LINE OPTIONS ====================================
-	j = ParseCommandLineOptions(argc, argv, molecules, periode, configuration, ConfigFileName);
-	switch(j) {
-	  case 0:  // something went wrong
-	    delete(molecules); // also free's all molecules contained
-	    delete(periode);
-	    return j;
-	    break;
-	  case 1:  // just for -v and -h options
-	    delete(molecules); // also free's all molecules contained
-	    delete(periode);
-	    return 0;
-	    break;
-	  default:
-	    break;
-	}
-
-	// General stuff
-	if (molecules->ListOfMolecules.size() == 0) {
+  periodentafel *periode = new periodentafel; // and a period table of all elements
+  MoleculeListClass *molecules = new MoleculeListClass;  // list of all molecules
+  molecule *mol = NULL;
+  config configuration;
+  char choice;  // menu choice char
+  Vector x,y,z,n;  // coordinates for absolute point in cell volume
+  ifstream test;
+  ofstream output;
+  string line;
+  char *ConfigFileName = NULL;
+  int j;
+
+  // =========================== PARSE COMMAND LINE OPTIONS ====================================
+  j = ParseCommandLineOptions(argc, argv, molecules, periode, configuration, ConfigFileName);
+  switch(j) {
+    case 255:  // something went wrong
+      delete(molecules); // also free's all molecules contained
+      delete(periode);
+      return j;
+      break;
+    case 1:  // just for -v and -h options
+      delete(molecules); // also free's all molecules contained
+      delete(periode);
+      return 0;
+      break;
+    default:
+      break;
+  }
+
+  // General stuff
+  if (molecules->ListOfMolecules.size() == 0) {
     mol = new molecule(periode);
     if (mol->cell_size[0] == 0.) {
@@ -1819,17 +1977,17 @@
     }
     molecules->insert(mol);
-	}
-
-	// =========================== START INTERACTIVE SESSION ====================================
-
-	// now the main construction loop
-	cout << Verbose(0) << endl << "Now comes the real construction..." << endl;
-	do {
-		cout << Verbose(0) << endl << endl;
-		cout << Verbose(0) << "============Molecule list=======================" << endl;
-		molecules->Enumerate((ofstream *)&cout);
-		cout << Verbose(0) << "============Menu===============================" << endl;
+  }
+
+  // =========================== START INTERACTIVE SESSION ====================================
+
+  // now the main construction loop
+  cout << Verbose(0) << endl << "Now comes the real construction..." << endl;
+  do {
+    cout << Verbose(0) << endl << endl;
+    cout << Verbose(0) << "============Molecule list=======================" << endl;
+    molecules->Enumerate((ofstream *)&cout);
+    cout << Verbose(0) << "============Menu===============================" << endl;
     cout << Verbose(0) << "a - set molecule (in)active" << endl;
-    cout << Verbose(0) << "e - edit new molecules" << endl;
+    cout << Verbose(0) << "e - edit molecules (load, parse, save)" << endl;
     cout << Verbose(0) << "g - globally manipulate atoms in molecule" << endl;
     cout << Verbose(0) << "M - Merge molecules" << endl;
@@ -1845,20 +2003,18 @@
     cin >> choice;
 
-		switch (choice) {
-			case 'a':  // (in)activate molecule
+    switch (choice) {
+      case 'a':  // (in)activate molecule
         {
           cout << "Enter index of molecule: ";
           cin >> j;
-          count = 1;
-          MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin();
-          for(; ((ListRunner != molecules->ListOfMolecules.end()) && (count < j)); ListRunner++);
-          if (count == j)
-            (*ListRunner)->ActiveFlag = !(*ListRunner)->ActiveFlag;
+          for(MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++)
+            if ((*ListRunner)->IndexNr == j)
+              (*ListRunner)->ActiveFlag = !(*ListRunner)->ActiveFlag;
         }
-			  break;
-
-			case 'c': // edit each field of the configuration
-			 configuration.Edit();
-			 break;
+        break;
+
+      case 'c': // edit each field of the configuration
+       configuration.Edit();
+       break;
 
       case 'e': // create molecule
@@ -1878,29 +2034,29 @@
         break;
 
-			case 'q': // quit
-				break;
-
-			case 's': // save to config file
-				SaveConfig(ConfigFileName, &configuration, periode, molecules);
-				break;
-
-			case 'T':
-				testroutine(molecules);
-				break;
-
-			default:
-			  break;
-		};
-	} while (choice != 'q');
-
-	// save element data base
-	if (periode->StorePeriodentafel(configuration.databasepath)) //ElementsFileName
-		cout << Verbose(0) << "Saving of elements.db successful." << endl;
-	else
-		cout << Verbose(0) << "Saving of elements.db failed." << endl;
-
-	delete(molecules); // also free's all molecules contained
-	delete(periode);
-	return (0);
+      case 'q': // quit
+        break;
+
+      case 's': // save to config file
+        SaveConfig(ConfigFileName, &configuration, periode, molecules);
+        break;
+
+      case 'T':
+        testroutine(molecules);
+        break;
+
+      default:
+        break;
+    };
+  } while (choice != 'q');
+
+  // save element data base
+  if (periode->StorePeriodentafel(configuration.databasepath)) //ElementsFileName
+    cout << Verbose(0) << "Saving of elements.db successful." << endl;
+  else
+    cout << Verbose(0) << "Saving of elements.db failed." << endl;
+
+  delete(molecules); // also free's all molecules contained
+  delete(periode);
+  return (0);
 }
 
Index: src/config.cpp
===================================================================
--- src/config.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/config.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -7,4 +7,154 @@
 #include "molecules.hpp"
 
+/******************************** Functions for class ConfigFileBuffer **********************/
+
+/** Structure containing compare function for Ion_Type sorting.
+ */
+struct IonTypeCompare {
+  bool operator()(const char* s1, const char *s2) const {
+    char number1[8];
+    char number2[8];
+    char *dummy1, *dummy2;
+    //cout << s1 << "  " << s2 << endl;
+    dummy1 = strchr(s1, '_')+sizeof(char)*5;  // go just after "Ion_Type"
+    dummy2 = strchr(dummy1, '_');
+    strncpy(number1, dummy1, dummy2-dummy1); // copy the number
+    number1[dummy2-dummy1]='\0';
+    dummy1 = strchr(s2, '_')+sizeof(char)*5;  // go just after "Ion_Type"
+    dummy2 = strchr(dummy1, '_');
+    strncpy(number2, dummy1, dummy2-dummy1); // copy the number
+    number2[dummy2-dummy1]='\0';
+    if (atoi(number1) != atoi(number2))
+      return (atoi(number1) < atoi(number2));
+    else {
+      dummy1 = strchr(s1, '_')+sizeof(char);
+      dummy1 = strchr(dummy1, '_')+sizeof(char);
+      dummy2 = strchr(dummy1, ' ') < strchr(dummy1, '\t') ? strchr(dummy1, ' ') : strchr(dummy1, '\t');
+      strncpy(number1, dummy1, dummy2-dummy1); // copy the number
+      number1[dummy2-dummy1]='\0';
+      dummy1 = strchr(s2, '_')+sizeof(char);
+      dummy1 = strchr(dummy1, '_')+sizeof(char);
+      dummy2 = strchr(dummy1, ' ') < strchr(dummy1, '\t') ? strchr(dummy1, ' ') : strchr(dummy1, '\t');
+      strncpy(number2, dummy1, dummy2-dummy1); // copy the number
+      number2[dummy2-dummy1]='\0';
+      return (atoi(number1) < atoi(number2));
+    }
+  }
+};
+
+/** Constructor for ConfigFileBuffer class.
+ */
+ConfigFileBuffer::ConfigFileBuffer()
+{
+  NoLines = 0;
+  CurrentLine = 0;
+  buffer = NULL;
+  LineMapping = NULL;
+}
+
+/** Constructor for ConfigFileBuffer class with filename to be parsed.
+ * \param *filename file name
+ */
+ConfigFileBuffer::ConfigFileBuffer(char *filename)
+{
+  NoLines = 0;
+  CurrentLine = 0;
+  buffer = NULL;
+  LineMapping = NULL;
+  ifstream *file = NULL;
+  char line[MAXSTRINGSIZE];
+
+  // prescan number of lines
+  file= new ifstream(filename);
+  if (file == NULL) {
+    cerr << "ERROR: config file " << filename << " missing!" << endl;
+    return;
+  }
+  NoLines = 0; // we're overcounting by one
+  long file_position = file->tellg(); // mark current position
+  do {
+    file->getline(line, 256);
+    NoLines++;
+  } while (!file->eof());
+  file->clear();
+  file->seekg(file_position, ios::beg);
+  cout << Verbose(1) << NoLines-1 << " lines were recognized." << endl;
+
+  // allocate buffer's 1st dimension
+  if (buffer != NULL) {
+    cerr << "ERROR: FileBuffer->buffer is not NULL!" << endl;
+    return;
+  } else
+    buffer = (char **) Malloc(sizeof(char *)*NoLines, "ConfigFileBuffer::ConfigFileBuffer: **buffer");
+
+  // scan each line and put into buffer
+  int lines=0;
+  int i;
+  do {
+    buffer[lines] = (char *) Malloc(sizeof(char)*MAXSTRINGSIZE, "ConfigFileBuffer::ConfigFileBuffer: *buffer[]");
+    file->getline(buffer[lines], MAXSTRINGSIZE-1);
+    i = strlen(buffer[lines]);
+    buffer[lines][i] = '\n';
+    buffer[lines][i+1] = '\0';
+    lines++;
+  } while((!file->eof()) && (lines < NoLines));
+  cout << Verbose(1) << lines-1 << " lines were read into the buffer." << endl;
+
+  // close and exit
+  file->close();
+  file->clear();
+  delete(file);
+}
+
+/** Destructor for ConfigFileBuffer class.
+ */
+ConfigFileBuffer::~ConfigFileBuffer()
+{
+  for(int i=0;i<NoLines;++i)
+    Free((void **)&buffer[i], "ConfigFileBuffer::~ConfigFileBuffer: *buffer[]");
+  Free((void **)&buffer, "ConfigFileBuffer::~ConfigFileBuffer: **buffer");
+  Free((void **)&LineMapping, "ConfigFileBuffer::~ConfigFileBuffer: *LineMapping");
+}
+
+
+/** Create trivial mapping.
+ */
+void ConfigFileBuffer::InitMapping()
+{
+  LineMapping = (int *) Malloc(sizeof(int)*NoLines, "ConfigFileBuffer::InitMapping: *LineMapping");
+  for (int i=0;i<NoLines;i++)
+    LineMapping[i] = i;
+}
+
+/** Creates a mapping for the \a *FileBuffer's lines containing the Ion_Type keyword such that they are sorted.
+ * \a *map on return contains a list of NoAtom entries such that going through the list, yields indices to the
+ * lines in \a *FileBuffer in a sorted manner of the Ion_Type?_? keywords. We assume that ConfigFileBuffer::CurrentLine
+ * points to first Ion_Type entry.
+ * \param *FileBuffer pointer to buffer structure
+ * \param NoAtoms of subsequent lines to look at
+ */
+void ConfigFileBuffer::MapIonTypesInBuffer(int NoAtoms)
+{
+  map<const char *, int, IonTypeCompare> LineList;
+  if (LineMapping == NULL) {
+    cerr << "map pointer is NULL: " << LineMapping << endl;
+    return;
+  }
+
+  // put all into hashed map
+  for (int i=0; i<NoAtoms; ++i) {
+    LineList.insert(pair<const char *, int> (buffer[CurrentLine+i], CurrentLine+i));
+  }
+
+  // fill map
+  int nr=0;
+  for (map<const char *, int, IonTypeCompare>::iterator runner = LineList.begin(); runner != LineList.end(); ++runner) {
+    if (CurrentLine+nr < NoLines)
+      LineMapping[CurrentLine+(nr++)] = runner->second;
+    else
+      cerr << "config::MapIonTypesInBuffer - NoAtoms is wrong: We are past the end of the file!" << endl;
+  }
+}
+
 /************************************* Functions for class config ***************************/
 
@@ -13,75 +163,97 @@
 config::config()
 {
-	mainname = (char *) MallocString(sizeof(char)*MAXSTRINGSIZE,"config constructor: mainname");
-	defaultpath = (char *) MallocString(sizeof(char)*MAXSTRINGSIZE,"config constructor: defaultpath");
-	pseudopotpath = (char *) MallocString(sizeof(char)*MAXSTRINGSIZE,"config constructor: pseudopotpath");
+  mainname = (char *) MallocString(sizeof(char)*MAXSTRINGSIZE,"config constructor: mainname");
+  defaultpath = (char *) MallocString(sizeof(char)*MAXSTRINGSIZE,"config constructor: defaultpath");
+  pseudopotpath = (char *) MallocString(sizeof(char)*MAXSTRINGSIZE,"config constructor: pseudopotpath");
   databasepath = (char *) MallocString(sizeof(char)*MAXSTRINGSIZE,"config constructor: databasepath");
-	configpath = (char *) MallocString(sizeof(char)*MAXSTRINGSIZE,"config constructor: configpath");
-	configname = (char *) MallocString(sizeof(char)*MAXSTRINGSIZE,"config constructor: configname");
-	strcpy(mainname,"pcp");
-	strcpy(defaultpath,"not specified");
-	strcpy(pseudopotpath,"not specified");
-	configpath[0]='\0';
-	configname[0]='\0';
-	basis = "3-21G";
-
-	FastParsing = false;
-	ProcPEGamma=8;
-	ProcPEPsi=1;
-	DoOutVis=0;
-	DoOutMes=1;
-	DoOutNICS=0;
-	DoOutOrbitals=0;
-	DoOutCurrent=0;
-	DoPerturbation=0;
-	DoFullCurrent=0;
-	DoWannier=0;
-	CommonWannier=0;
-	SawtoothStart=0.01;
-	VectorPlane=0;
-	VectorCut=0;
-	UseAddGramSch=1;
-	Seed=1;
-
-	MaxOuterStep=0;
-	Deltat=1;
-	OutVisStep=10;
-	OutSrcStep=5;
-	TargetTemp=0.00095004455;
-	ScaleTempStep=25;
-	MaxPsiStep=0;
-	EpsWannier=1e-7;
-
-	MaxMinStep=100;
-	RelEpsTotalEnergy=1e-7;
-	RelEpsKineticEnergy=1e-5;
-	MaxMinStopStep=1;
-	MaxMinGapStopStep=0;
-	MaxInitMinStep=100;
-	InitRelEpsTotalEnergy=1e-5;
-	InitRelEpsKineticEnergy=1e-4;
-	InitMaxMinStopStep=1;
-	InitMaxMinGapStopStep=0;
-
-	//BoxLength[NDIM*NDIM];
-
-	ECut=128.;
-	MaxLevel=5;
-	RiemannTensor=0;
-	LevRFactor=0;
-	RiemannLevel=0;
-	Lev0Factor=2;
-	RTActualUse=0;
-	PsiType=0;
-	MaxPsiDouble=0;
-	PsiMaxNoUp=0;
-	PsiMaxNoDown=0;
-	AddPsis=0;
-
-	RCut=20.;
-	StructOpt=0;
-	IsAngstroem=1;
-	RelativeCoord=0;
-	MaxTypes=0;
+  configpath = (char *) MallocString(sizeof(char)*MAXSTRINGSIZE,"config constructor: configpath");
+  configname = (char *) MallocString(sizeof(char)*MAXSTRINGSIZE,"config constructor: configname");
+  ThermostatImplemented = (int *) Malloc((MaxThermostats)*(sizeof(int)), "config constructor: *ThermostatImplemented");
+  ThermostatNames = (char **) Malloc((MaxThermostats)*(sizeof(char *)), "config constructor: *ThermostatNames");
+  for (int j=0;j<MaxThermostats;j++)
+    ThermostatNames[j] = (char *) MallocString(12*(sizeof(char)), "config constructor: ThermostatNames[]");
+  Thermostat = 4;
+  alpha = 0.;
+  ScaleTempStep = 25;
+  TempFrequency = 2.5;
+  strcpy(mainname,"pcp");
+  strcpy(defaultpath,"not specified");
+  strcpy(pseudopotpath,"not specified");
+  configpath[0]='\0';
+  configname[0]='\0';
+  basis = "3-21G";
+
+  strcpy(ThermostatNames[0],"None");
+  ThermostatImplemented[0] = 1;
+  strcpy(ThermostatNames[1],"Woodcock"); 
+  ThermostatImplemented[1] = 1;
+  strcpy(ThermostatNames[2],"Gaussian"); 
+  ThermostatImplemented[2] = 1;
+  strcpy(ThermostatNames[3],"Langevin"); 
+  ThermostatImplemented[3] = 1;
+  strcpy(ThermostatNames[4],"Berendsen"); 
+  ThermostatImplemented[4] = 1;
+  strcpy(ThermostatNames[5],"NoseHoover"); 
+  ThermostatImplemented[5] = 1;
+
+  FastParsing = false;
+  ProcPEGamma=8;
+  ProcPEPsi=1;
+  DoOutVis=0;
+  DoOutMes=1;
+  DoOutNICS=0;
+  DoOutOrbitals=0;
+  DoOutCurrent=0;
+  DoPerturbation=0;
+  DoFullCurrent=0;
+  DoWannier=0;
+  DoConstrainedMD=0;
+  CommonWannier=0;
+  SawtoothStart=0.01;
+  VectorPlane=0;
+  VectorCut=0;
+  UseAddGramSch=1;
+  Seed=1;
+
+  MaxOuterStep=0;
+  Deltat=0.01;
+  OutVisStep=10;
+  OutSrcStep=5;
+  TargetTemp=0.00095004455;
+  ScaleTempStep=25;
+  MaxPsiStep=0;
+  EpsWannier=1e-7;
+
+  MaxMinStep=100;
+  RelEpsTotalEnergy=1e-7;
+  RelEpsKineticEnergy=1e-5;
+  MaxMinStopStep=1;
+  MaxMinGapStopStep=0;
+  MaxInitMinStep=100;
+  InitRelEpsTotalEnergy=1e-5;
+  InitRelEpsKineticEnergy=1e-4;
+  InitMaxMinStopStep=1;
+  InitMaxMinGapStopStep=0;
+
+  //BoxLength[NDIM*NDIM];
+
+  ECut=128.;
+  MaxLevel=5;
+  RiemannTensor=0;
+  LevRFactor=0;
+  RiemannLevel=0;
+  Lev0Factor=2;
+  RTActualUse=0;
+  PsiType=0;
+  MaxPsiDouble=0;
+  PsiMaxNoUp=0;
+  PsiMaxNoDown=0;
+  AddPsis=0;
+
+  RCut=20.;
+  StructOpt=0;
+  IsAngstroem=1;
+  RelativeCoord=0;
+  MaxTypes=0;
 };
 
@@ -91,11 +263,91 @@
 config::~config()
 {
-	Free((void **)&mainname, "config::~config: *mainname");
-	Free((void **)&defaultpath, "config::~config: *defaultpath");
-	Free((void **)&pseudopotpath, "config::~config: *pseudopotpath");
+  Free((void **)&mainname, "config::~config: *mainname");
+  Free((void **)&defaultpath, "config::~config: *defaultpath");
+  Free((void **)&pseudopotpath, "config::~config: *pseudopotpath");
   Free((void **)&databasepath, "config::~config: *databasepath");
-	Free((void **)&configpath, "config::~config: *configpath");
-	Free((void **)&configname, "config::~config: *configname");
+  Free((void **)&configpath, "config::~config: *configpath");
+  Free((void **)&configname, "config::~config: *configname");
+  Free((void **)&ThermostatImplemented, "config::~config: *ThermostatImplemented");
+  for (int j=0;j<MaxThermostats;j++)
+    Free((void **)&ThermostatNames[j], "config::~config: *ThermostatNames[]");
+  Free((void **)&ThermostatNames, "config::~config: **ThermostatNames");
 };
+
+/** Readin of Thermostat related values from parameter file.
+ * \param *source parameter file
+ */
+void config::InitThermostats(ifstream *source)
+{
+  char *thermo = MallocString(12, "IonsInitRead: thermo");
+  int verbose = 0;
+
+  // read desired Thermostat from file along with needed additional parameters
+  if (ParseForParameter(verbose,source,"Thermostat", 0, 1, 1, string_type, thermo, 1, optional)) {
+    if (strcmp(thermo, ThermostatNames[0]) == 0) { // None
+      if (ThermostatImplemented[0] == 1) {
+        Thermostat = None;
+      } else {
+        cout << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
+        Thermostat = None;
+      }
+    } else if (strcmp(thermo, ThermostatNames[1]) == 0) { // Woodcock
+      if (ThermostatImplemented[1] == 1) {
+        Thermostat = Woodcock;
+        ParseForParameter(verbose,source,"Thermostat", 0, 2, 1, int_type, &ScaleTempStep, 1, critical); // read scaling frequency
+      } else {
+        cout << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
+        Thermostat = None;
+      }
+    } else if (strcmp(thermo, ThermostatNames[2]) == 0) { // Gaussian
+      if (ThermostatImplemented[2] == 1) {
+        Thermostat = Gaussian;
+        ParseForParameter(verbose,source,"Thermostat", 0, 2, 1, int_type, &ScaleTempStep, 1, critical); // read collision rate
+      } else {
+        cout << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
+        Thermostat = None;
+      }
+    } else if (strcmp(thermo, ThermostatNames[3]) == 0) { // Langevin
+      if (ThermostatImplemented[3] == 1) {
+        Thermostat = Langevin;
+        ParseForParameter(verbose,source,"Thermostat", 0, 2, 1, double_type, &TempFrequency, 1, critical); // read gamma
+        if (ParseForParameter(verbose,source,"Thermostat", 0, 3, 1, double_type, &alpha, 1, optional)) {
+          cout << Verbose(2) << "Extended Stochastic Thermostat detected with interpolation coefficient " << alpha << "." << endl;
+        } else {
+          alpha = 1.;
+        }
+      } else {
+        cout << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
+        Thermostat = None;
+      }
+    } else if (strcmp(thermo, ThermostatNames[4]) == 0) { // Berendsen
+      if (ThermostatImplemented[4] == 1) {
+        Thermostat = Berendsen;
+        ParseForParameter(verbose,source,"Thermostat", 0, 2, 1, double_type, &TempFrequency, 1, critical); // read \tau_T
+      } else {
+        cout << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
+        Thermostat = None;
+      }
+    } else if (strcmp(thermo, ThermostatNames[5]) == 0) { // Nose-Hoover
+      if (ThermostatImplemented[5] == 1) {
+        Thermostat = NoseHoover;
+        ParseForParameter(verbose,source,"Thermostat", 0, 2, 1, double_type, &HooverMass, 1, critical); // read Hoovermass
+        alpha = 0.;
+      } else {
+        cout << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
+        Thermostat = None;
+      }
+    } else {
+      cout << Verbose(1) << " Warning: thermostat name was not understood!" << endl;
+      Thermostat = None;
+    }
+  } else {
+    if ((MaxOuterStep > 0) && (TargetTemp != 0)) 
+      cout << Verbose(2) <<  "No thermostat chosen despite finite temperature MD, falling back to None." << endl;
+    Thermostat = None;
+  }
+  Free((void **)&thermo, "InitThermostats: thermo");
+};
+
 
 /** Displays menu for editing each entry of the config file.
